Magellan Linux

Annotation of /tags/grubby-8_40_20170706/new-kernel-pkg

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2681 - (hide annotations) (download)
Wed Jul 16 09:48:55 2014 UTC (9 years, 9 months ago) by niro
Original Path: trunk/grubby/new-kernel-pkg
File size: 23068 byte(s)
-honor all /etc/os-release files
1 niro 532 #!/bin/bash
2 niro 924 # $Id$
3 niro 532 #
4 niro 923 # new-kernel-pkg
5 niro 532 # Invoked upon installation or removal of a kernel package, the following
6     # tasks are/can be done here:
7     # creation/removal of initrd
8     # run of depmod/removal of depmod generated files
9     # addition/removal of kernel images from grub/lilo configuration (via grubby)
10     #
11 niro 923 # Copyright 2002-2008 Red Hat, Inc. All rights reserved.
12 niro 532 # modified for Magellan-Linux by Niels Rogalla <niro@magellan-linux.de>
13     #
14 niro 923 # This program is free software; you can redistribute it and/or modify
15     # it under the terms of the GNU General Public License as published by
16     # the Free Software Foundation; either version 2 of the License, or
17     # (at your option) any later version.
18     #
19     # This program is distributed in the hope that it will be useful,
20     # but WITHOUT ANY WARRANTY; without even the implied warranty of
21     # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
22     # GNU General Public License for more details.
23     #
24     # You should have received a copy of the GNU General Public License
25     # along with this program. If not, see <http://www.gnu.org/licenses/>.
26     #
27 niro 532
28 niro 1778 read_os_release()
29     {
30     local NAME
31     local ID
32     local Version
33     local Version_ID
34     local PRETTY_NAME
35     local ANSI_COLOR
36     local CPE_NAME
37    
38     if [[ -f /etc/os-release ]]
39     then
40     source /etc/os-release
41    
42     case $1 in
43     name) echo "${NAME}" ;;
44     id) echo "${ID}" ;;
45     version) echo "${Version}" ;;
46     version_id) echo "${Version_ID}" ;;
47     pretty_name) echo "${PRETTY_NAME}" ;;
48     ansi_color) echo "${ANSI_COLOR}" ;;
49     cpe_name) echo "${CPE_NAME}" ;;
50     esac
51     fi
52     }
53    
54 niro 532 PATH=/sbin:/bin:$PATH
55    
56     lilo=/sbin/lilo
57    
58     # some defaults that are sane for most arches
59     kernelName=kernel
60    
61 niro 924 if [ -x ./grubby ]
62     then
63     grubby=./grubby
64 niro 532 else
65 niro 924 grubby=/sbin/grubby
66 niro 532 fi
67    
68 niro 925 [ -f /etc/conf.d/grubby ] && . /etc/conf.d/grubby
69 niro 1691 [ -f /etc/conf.d/grubby-uboot ] && . /etc/conf.d/grubby-uboot
70 niro 532
71 niro 1697 cfgGrub2=""
72     cfgGrub2Efi=""
73 niro 532 cfgGrub=""
74     cfgLilo=""
75 niro 1716 cfgExtlinux=""
76 niro 1691 cfguBoot=""
77 niro 532 runLilo=""
78     grubConfig=""
79 niro 1702 grub2Config=""
80     grub2EfiConfig=""
81 niro 1716 extlinuxConfig=""
82 niro 532
83     ARCH=$(uname -m)
84    
85 niro 924 if [[ ${ARCH} = ia64 ]]
86     then
87     liloConfig=/boot/efi/EFI/redhat/elilo.conf
88     bootPrefix=/boot/efi/EFI/redhat
89     liloFlag=elilo
90     isx86=""
91     elif [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
92     then
93     liloConfig=/etc/yaboot.conf
94 niro 1803 grub2Config=/boot/grub/grub.cfg
95 niro 924 bootPrefix=/boot
96     lilo=/sbin/ybin
97     liloFlag=yaboot
98     runLilo="yes"
99     isx86=""
100     elif [[ ${ARCH} = sparc ]] || [[ ${ARCH} = sparc64 ]]
101     then
102     liloConfig=/etc/silo.conf
103     bootPrefix=/boot
104     liloFlag=silo
105     lilo=/sbin/silo
106     isx86=""
107     elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
108     then
109     liloConfig=/etc/zipl.conf
110     bootPrefix=/boot
111     liloFlag=zipl
112     lilo=/sbin/zipl
113     runLilo="yes"
114     isx86=""
115 niro 1848 elif [[ ${ARCH} =~ armv[5|7].*l ]]
116 niro 1691 then
117     liloConfig=""
118     bootPrefix=/boot
119 niro 2259 extlinuxConfig=$(readlink -f /etc/extlinux.conf 2>/dev/null)
120 niro 1847 ubootDir=${UBOOT_DIR:-"/boot"}
121 niro 1691 ubootScript=$ubootDir/${UBOOT_SCR:-"boot.scr"}
122     ubootKList=${UBOOT_KLIST:-"klist.txt"}
123     ubootDevice=/dev/${UBOOT_DEVICE:-"mmcblk0p1"}
124     ubootDefaultImage=${UBOOT_UIMAGE:-"uImage"}
125     ubootDefaultInitrd=${UBOOT_UINITRD:-"uInitrd"}
126 niro 1937 ubootAddress=${UBOOT_IMGADDR:-"0x00008000"}
127 niro 1691 mounted=""
128     liloFlag=""
129     isx86=""
130 niro 532 else
131 niro 924 # this leaves i?86 and x86_64
132     liloConfig=/etc/lilo.conf
133     grubConfig=/boot/grub/grub.conf
134 niro 1697 grub2Config=/boot/grub/grub.cfg
135     grub2EfiConfig=/boot/grub/grub-efi.cfg
136 niro 1716 extlinuxConfig=/boot/extlinux/extlinux.conf
137 niro 924 bootPrefix=/boot
138     liloFlag=lilo
139     isx86="yes"
140 niro 532 fi
141    
142     mode=""
143     version=""
144     initrd=""
145 niro 1334 dracut=""
146     dracuthostonly=""
147 niro 532 initrdfile=""
148     moddep=""
149     verbose=""
150     makedefault=""
151     package=""
152 niro 1706 mbkernel="${HYPERVISOR}"
153     mbargs="${HYPERVISOR_ARGS}"
154 niro 1334 adddracutargs=""
155     addplymouthinitrd=""
156 niro 532
157 niro 924 usage()
158     {
159 niro 1334 echo "Usage: $(basename $0) [-v] [--mkinitrd] [--rminitrd] [--dracut]" >&2
160 niro 924 echo " [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2
161 niro 1305 echo " [--kernel-args=<args>] [--remove-args=<args>]" >&2
162 niro 924 echo " [--banner=<banner>] [--multiboot=multiboot]" >&2
163 niro 1334 echo " [--mbargs=mbargs] [--make-default] [--add-dracut-args]" >&2
164     echo " [--add-plymouth-initrd]" >&2
165     echo " [--host-only]" >&2
166 niro 924 echo " <--install | --remove | --update> <kernel-version>" >&2
167     echo " (ex: $(basename $0) --mkinitrd --depmod --install 2.4.7-2)" >&2
168     exit 1
169 niro 532 }
170    
171 niro 924 install()
172     {
173     # XXX kernel should be able to be specified also (or work right on ia64)
174 niro 2241 if [ ! -f ${kernelImage} ]
175 niro 924 then
176     [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
177     return
178     fi
179 niro 923
180 niro 924 INITRD=""
181     if [ -f ${initrdfile} ]
182     then
183     [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
184     INITRD="--initrd ${initrdfile}"
185 niro 1334
186     if [[ -n ${addplymouthinitrd} ]]
187     then
188     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
189     fi
190 niro 924 fi
191 niro 532
192 niro 924 # FIXME: is this a good heuristic to find out if we're on iSeries?
193     if [ -d /proc/iSeries ]
194     then
195     [[ -n ${verbose} ]] && echo "On an iSeries, just making img file"
196     if [[ -z ${initrdfile} ]]
197     then
198     [[ -n ${verbose} ]] && echo "No initrd, just adding system map"
199 niro 2241 /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinitrd-${version}
200 niro 924 else
201 niro 2241 /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinux.sm-${version}
202 niro 924 /sbin/addRamDisk ${initrdfile} ${bootPrefix}/System.map-${version} ${bootPrefix}/vmlinux.sm-${version} ${bootPrefix}/vmlinitrd-${version} 2>/dev/null
203     rm ${bootPrefix}/vmlinux.sm-${version}
204     fi
205     return
206 niro 532 fi
207    
208 niro 924 # get the root filesystem to use
209 niro 2238 rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab 2>/dev/null)
210 niro 2237 if [[ -z $rootdevice ]]
211     then
212     rootdevice=$(grep -o -P "(?<=root=)\S+" /proc/cmdline)
213     fi
214 niro 532
215 niro 924 if [[ -n ${mbkernel} ]] && [[ -n ${cfgLilo} ]] && [[ ${liloFlag} != elilo ]]
216     then
217     [[ -n ${verbose} ]] && echo "multiboot specified, not updating lilo.conf"
218     cfgLilo=""
219     fi
220 niro 532
221 niro 2239 if [[ -n ${banner} ]]
222     then
223     title="${banner} [ ${version} ]"
224 niro 2681 elif [ -f /etc/os-release ]
225 niro 2239 then
226     title="$(read_os_release name) $(read_os_release version_id) [ ${version} ]"
227     elif [ -f /etc/mageversion ]
228     then
229     title="Magellan Linux $(< /etc/mageversion) [ ${version} ]"
230     else
231     title="Magellan Linux [ ${version} ]"
232     fi
233    
234 niro 924 if [[ -n ${cfgGrub} ]]
235     then
236     [[ -n ${verbose} ]] && echo "adding ${version} to ${grubConfig}"
237 niro 532
238 niro 1710 ${grubby} --grub -c ${grubConfig} \
239 niro 2241 --add-kernel=${kernelImage} \
240 niro 924 ${INITRD} --copy-default ${makedefault} --title "${title}" \
241     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
242     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
243 niro 532 else
244 niro 1697 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
245 niro 532 fi
246 niro 1697 if [[ -n ${cfgGrub2} ]]
247     then
248     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2Config}"
249 niro 532
250 niro 1702 ${grubby} --grub2 -c ${grub2Config} \
251 niro 2241 --add-kernel=${kernelImage} \
252 niro 1697 ${INITRD} --copy-default ${makedefault} --title "${title}" \
253     ${mbkernel:+--add-multiboot="${mbkernel}"} \
254     ${mbargs:+--mbargs="${mbargs}"} \
255     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
256     else
257     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
258     fi
259     if [[ -n ${cfgGrub2Efi} ]]
260     then
261     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2EfiConfig}"
262    
263 niro 1940 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
264 niro 2241 --add-kernel=${kernelImage} \
265 niro 1697 ${INITRD} --copy-default ${makedefault} --title "${title}" \
266     ${mbkernel:+--add-multiboot="${mbkernel}"} \
267     ${mbargs:+--mbargs="${mbargs}"} \
268     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
269     else
270     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby for grub 2 with UEFI"
271     fi
272    
273 niro 924 if [[ -n ${cfgLilo} ]]
274     then
275     [[ -n ${verbose} ]] && echo "adding ${version} to ${liloConfig}"
276 niro 532
277 niro 2241 ${grubby} --add-kernel=${kernelImage} ${INITRD} \
278 niro 924 --copy-default ${makedefault} --title ${version} \
279     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
280     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${version}" \
281     --${liloFlag}
282 niro 532
283 niro 924 if [[ -n ${runLilo} ]]
284     then
285     [[ -n ${verbose} ]] && echo "running ${lilo}"
286 niro 1305 if [ ! -x ${lilo} ]
287 niro 924 then
288     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
289     else
290     ${lilo} > /dev/null
291     fi
292     fi
293     else
294     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
295 niro 532 fi
296 niro 1716
297     if [[ -n ${cfgExtlinux} ]]
298     then
299     [[ -n ${verbose} ]] && echo "adding ${version} to ${extlinuxConfig}"
300    
301     ${grubby} --extlinux -c ${extlinuxConfig} \
302 niro 2241 --add-kernel=${kernelImage} \
303 niro 1716 ${INITRD} --copy-default ${makedefault} --title "${title}" \
304     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
305     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
306     else
307     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
308     fi
309 niro 532 }
310    
311 niro 924 remove()
312     {
313     # FIXME: is this a good heuristic to find out if we're on iSeries?
314     if [ -d /proc/iSeries ]
315     then
316     [[ -n ${verbose} ]] && echo "On an iSeries, remove img file"
317 niro 2241 rm -f ${kernelImage}.img 2>/dev/null
318 niro 924 return
319     fi
320 niro 532
321 niro 924 if [[ -n ${cfgGrub} ]]
322     then
323     [[ -n ${verbose} ]] && echo "removing ${version} from ${grubConfig}"
324 niro 1710 ${grubby} --grub -c ${grubConfig} \
325 niro 2241 --remove-kernel=${kernelImage}
326 niro 924 else
327 niro 1697 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
328 niro 924 fi
329 niro 1697 if [[ -n ${cfgGrub2} ]]
330     then
331     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2Config}"
332     ${grubby} --grub2 -c ${grub2Config} \
333 niro 2241 --remove-kernel=${kernelImage}
334 niro 1697 else
335     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
336     fi
337     if [[ -n ${cfgGrub2Efi} ]]
338     then
339     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2EfiConfig}"
340 niro 2051 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
341 niro 2241 --remove-kernel=${kernelImage}
342 niro 1697 else
343     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby grub 2 with UEFI"
344     fi
345 niro 532
346 niro 924 if [[ -n ${cfgLilo} ]]
347     then
348     [[ -n ${verbose} ]] && echo "removing ${version} from ${liloConfig}"
349 niro 2241 ${grubby} --remove-kernel=${kernelImage} --${liloFlag}
350 niro 532
351 niro 924 if [[ -n ${runLilo} ]]
352     then
353     [[ -n ${verbose} ]] && echo "running ${lilo}"
354     if [ ! -x ${lilo} ]
355     then
356     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
357     else
358     ${lilo} > /dev/null
359     fi
360     fi
361     else
362     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
363 niro 532 fi
364 niro 1691
365     if [[ -n ${cfguBoot} ]]
366     then
367     [[ -n ${verbose} ]] && echo "removing ${version} from ${ubootDir}..."
368    
369     if [ -f ${ubootDir}/${ubootKList} ]
370     then
371     tmpKList=$(mktemp ${ubootDir}/${ubootKList}.XXXX)
372     curversion=$(tail -n1 ${ubootDir}/${ubootKList})
373 niro 1847 sed "/$version$/d" ${ubootDir}/${ubootKList} > ${tmpKList}
374 niro 1691 newversion=$(tail -n1 ${tmpKList})
375     if [ -f ${ubootDir}/uImage-${newversion} ] && [ -f ${ubootDir}/uInitrd-${newversion} ]
376     then
377     if [[ ${curversion} != ${newversion} ]]
378     then
379     cp -fp ${ubootDir}/uImage-${newversion} ${ubootDir}/${ubootDefaultImage}
380     if [ $? -ne 0 ]
381     then
382     [[ -n ${verbose} ]] && echo "copy uImage-${newversion} error, default kernel not replaced!" && exit
383     fi
384     cp -fp ${ubootDir}/uInitrd-${newversion} ${ubootDir}/${ubootDefaultInitrd}
385     if [ $? -ne 0 ]
386     then
387     [[ -n ${verbose} ]] && echo "copy uInitrd-${newversion} error, default Initrd not replaced!" && exit
388     fi
389     fi
390    
391     [[ -n ${verbose} ]] && echo "removing uImage-${version}"
392     if [ -f ${ubootDir}/uImage-${version} ]
393     then
394     rm -f ${ubootDir}/uImage-${version}
395     else
396     [[ -n ${verbose} ]] && echo "uImage-${version} did not exist!"
397     fi
398    
399     [[ -n ${verbose} ]] && echo "removing uInitrd-${version}"
400     if [ -f ${ubootDir}/uInitrd-${version} ]
401     then
402     rm -f ${ubootDir}/uInitrd-${version}
403     else
404     [[ -n ${verbose} ]] && echo "uInitrd-${version} did not exist!"
405     fi
406    
407     mv ${tmpKList} ${ubootDir}/${ubootKList}
408 niro 2248 [ -x /sbin/a-b-c ] && /sbin/a-b-c
409 niro 1691 else
410     [[ -n ${verbose} ]] && echo "uImage ${newversion} does not exist!"
411     [ -f ${tmpKList} ] && rm -f ${tmpKList}
412     fi
413     else
414 niro 1752 [[ -n ${verbose} ]] && echo "No previous kernel version. U-Boot images not removed!"
415 niro 1691 fi
416     else
417     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not modifying ${ubootDir}"
418     fi
419 niro 1716
420     if [[ -n ${cfgExtlinux} ]]
421     then
422     [[ -n ${verbose} ]] && echo "removing ${version} from ${extlinuxConfig}"
423     ${grubby} --extlinux -c ${extlinuxConfig} \
424 niro 2241 --remove-kernel=${kernelImage}
425 niro 1716 else
426     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
427     fi
428 niro 532 }
429    
430 niro 924 update()
431     {
432 niro 2241 if [ ! -f ${kernelImage} ]
433 niro 1305 then
434     [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
435     return
436     fi
437    
438     INITRD=""
439     if [ -f ${initrdfile} ]
440     then
441     [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
442     INITRD="--initrd ${initrdfile}"
443 niro 1334
444     if [[ -n ${addplymouthinitrd} ]]
445     then
446     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
447     fi
448 niro 1305 fi
449    
450 niro 924 if [[ -n ${cfgGrub} ]]
451     then
452     [[ -n ${verbose} ]] && echo "updating ${version} from ${grubConfig}"
453 niro 1710 ${grubby} --grub -c ${grubConfig} \
454 niro 2241 --update-kernel=${kernelImage} \
455 niro 1305 ${INITRD} \
456 niro 924 ${kernargs:+--args="${kernargs}"} \
457 niro 2263 ${removeargs:+--remove-args="${removeargs}"} \
458     ${mbkernel:+--add-multiboot="${mbkernel}"}
459 niro 924 else
460     [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"
461     fi
462 niro 923
463 niro 1697 if [[ -n ${cfgGrub2} ]]
464     then
465     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2Config}"
466     ${grubby} --grub2 -c ${grub2Config} \
467 niro 2241 --update-kernel=${kernelImage} \
468 niro 1697 ${INITRD} \
469     ${kernargs:+--args="${kernargs}"} \
470     ${removeargs:+--remove-args="${removeargs}"}
471     else
472     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby"
473     fi
474    
475     if [[ -n ${cfgGrub2Efi} ]]
476     then
477     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2EfiConfig}"
478 niro 2051 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
479 niro 2241 --update-kernel=${kernelImage} \
480 niro 1697 ${INITRD} \
481     ${kernargs:+--args="${kernargs}"} \
482     ${removeargs:+--remove-args="${removeargs}"}
483     else
484     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby"
485     fi
486    
487 niro 924 if [[ -n ${cfgLilo} ]]
488     then
489     [[ -n ${verbose} ]] && echo "updating ${version} from ${liloConfig}"
490 niro 2241 ${grubby} --update-kernel=${kernelImage} \
491 niro 1305 ${INITRD} \
492 niro 924 ${kernargs:+--args="${kernargs}"} \
493     ${removeargs:+--remove-args="${removeargs}"} \
494     --${liloFlag}
495 niro 923
496 niro 924 if [[ -n ${runLilo} ]]
497     then
498     [[ -n ${verbose} ]] && echo "running ${lilo}"
499     if [ ! -x ${lilo} ]
500     then
501     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
502     else
503     ${lilo} > /dev/null
504     fi
505     fi
506     else
507     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
508 niro 923 fi
509 niro 1691
510     if [[ -n ${cfguBoot} ]]
511     then
512     [[ -n ${verbose} ]] && echo "adding $version to ${ubootDir}..."
513    
514     [[ -n ${verbose} ]] && echo "creating uImage-${version}"
515 niro 1752 mkimage -A arm -O linux -T kernel -C none -a ${ubootAddress} \
516     -e ${ubootAddress} -n ${version} \
517 niro 2241 -d ${kernelImage} ${ubootDir}/uImage-${version}
518 niro 1691
519     [[ -n ${verbose} ]] && echo "creating uInitrd-${version}"
520     mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
521     -n initramfs -d ${initrdfile} ${ubootDir}/uInitrd-${version}
522    
523     if [ -f ${ubootDir}/uImage-${version} ] && [ -f ${ubootDir}/uInitrd-${version} ]
524     then
525     cp -fp ${ubootDir}/uImage-${version} ${ubootDir}/${ubootDefaultImage}
526     if [ $? -ne 0 ]
527     then
528     [[ -n ${verbose} ]] && echo "copy uImage-${version} error, kernel not installed!" && exit
529     fi
530     cp -fp ${ubootDir}/uInitrd-${version} ${ubootDir}/${ubootDefaultInitrd}
531     if [ $? -ne 0 ]
532     then
533     [[ -n ${verbose} ]] && echo "copy uInitrd-${version} error, kernel not installed!" && exit
534     fi
535     echo ${version} >> ${ubootDir}/${ubootKList}
536 niro 2248 [ -x /sbin/a-b-c ] && /sbin/a-b-c
537 niro 1691 else
538     [[ -n ${verbose} ]] && echo "cannot make ${version} the default"
539     fi
540     else
541     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not setting up ${ubootDir}"
542     fi
543 niro 1716
544     if [[ -n ${cfgExtlinux} ]]
545     then
546     [[ -n ${verbose} ]] && echo "updating ${version} from ${extlinuxConfig}"
547     ${grubby} --extlinux -c ${extlinuxConfig} \
548 niro 2241 --update-kernel=${kernelImage} \
549 niro 1716 ${INITRD} \
550     ${kernargs:+--args="${kernargs}"} \
551     ${removeargs:+--remove-args="${removeargs}"}
552     else
553     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby"
554     fi
555 niro 923 }
556    
557 niro 1756 makeinitrd()
558 niro 924 {
559 niro 1334 if [[ -n ${dracut} ]]
560     then
561 niro 1728 tool="dracut ${dracuthostonly} -f ${initrdfile} ${version}"
562 niro 1334 else
563 niro 1749 tool="mkinitrd --allow-missing -f ${initrdfile} ${version}"
564 niro 1334 fi
565 niro 924 [[ -n ${verbose} ]] && echo "creating initrd ${initrdfile} using ${version}"
566 niro 1334 ${tool}
567 niro 924 rc=$?
568     if [ ${rc} != 0 ]
569     then
570     echo "mkinitrd failed" >&2
571     exit 1
572     fi
573 niro 532 }
574    
575 niro 924 rminitrd()
576     {
577     [[ -n ${verbose} ]] && echo "removing initrd ${initrdfile}"
578     [ -f ${initrdfile} ] && rm -f ${initrdfile}
579 niro 532 }
580    
581 niro 924 doDepmod()
582     {
583     [[ -n ${verbose} ]] && echo "running depmod for ${version}"
584     depmod -ae -F /boot/System.map-${version} ${version}
585 niro 532 }
586    
587 niro 924 doRmmoddep()
588     {
589     [[ -n ${verbose} ]] && echo "removing modules.dep info for ${version}"
590 niro 2242 if [ -d /lib/modules/${version} ]
591     then
592     rm -f /lib/modules/${version}/modules.*.bin \
593 niro 2244 /lib/modules/${version}/modules.{alias,dep,devname,symbols,softdep}
594 niro 2242 fi
595 niro 532 }
596    
597    
598 niro 924 while [ $# -gt 0 ]
599     do
600     case $1 in
601     --mkinitrd)
602     initrd="make"
603     ;;
604 niro 532
605 niro 924 --rminitrd)
606     initrd="remove"
607     ;;
608 niro 532
609 niro 1334 --dracut)
610     dracut=--dracut
611     ;;
612    
613     --host-only)
614     dracuthostonly=-H
615     ;;
616    
617 niro 924 --initrdfile*)
618 niro 2240 if [[ $1 == --initrdfile\=* ]]
619 niro 924 then
620 niro 2240 initrdfile=${1#--initrdfile=}
621 niro 924 else
622     initrdfile=$2
623     shift
624     fi
625     ;;
626 niro 532
627 niro 924 --kernel-args*)
628 niro 2240 if [[ $1 == --kernel-args\=* ]]
629 niro 924 then
630 niro 2240 kernargs=${1#--kernel-args=}
631 niro 924 else
632     kernargs=$2
633     shift
634     fi
635     ;;
636 niro 532
637 niro 924 --remove-args*)
638 niro 2240 if [[ $1 == --remove-args\=* ]]
639 niro 924 then
640 niro 2240 removeargs=${1#--remove-args=}
641 niro 924 else
642     removeargs=$2
643     shift
644     fi
645     ;;
646 niro 923
647 niro 924 --banner*)
648 niro 2240 if [[ $1 == --banner\=* ]]
649 niro 924 then
650 niro 2240 banner=${1#--banner=}
651 niro 924 else
652     banner=$2
653     shift
654     fi
655     ;;
656 niro 532
657 niro 924 --multiboot*)
658 niro 2240 if [[ $1 == --multiboot\=* ]]
659 niro 924 then
660 niro 2240 mbkernel=${1#--multiboot=}
661 niro 924 else
662     # can't really support having an optional second arg here
663     # sorry!
664     mbkernel="/boot/xen.gz"
665     fi
666     ;;
667 niro 532
668 niro 924 --mbargs*)
669 niro 2240 if [[ $1 == --mbargs\=* ]]
670 niro 924 then
671 niro 2240 mbargs=${1#--mbargs=}
672 niro 924 else
673     mbargs="$2"
674     shift
675     fi
676     ;;
677 niro 532
678 niro 924 --depmod)
679     moddep="make"
680     ;;
681 niro 532
682 niro 924 --rmmoddep)
683     moddep="remove"
684     ;;
685 niro 532
686 niro 924 --make-default)
687     makedefault="--make-default"
688     ;;
689 niro 532
690 niro 2240 --package*)
691     if [[ $1 == --package\=* ]]
692 niro 924 then
693 niro 2240 package=${1#--package=}
694 niro 924 else
695     package=$2
696     shift
697     fi
698     ;;
699 niro 532
700 niro 1334 --add-dracut-args)
701     adddracutargs=--add-dracut-args
702     ;;
703    
704     --add-plymouth-initrd)
705     addplymouthinitrd=--add-plymouth-initrd
706     ;;
707    
708 niro 2241 --kernel-image*)
709     if [[ $1 == --kernel-image\=* ]]
710     then
711     kernelImage=${1#--kernel-image=}
712     else
713     kernelImage="$2"
714     shift
715     fi
716     if ! [[ -f ${kernelImage} ]]
717     then
718     echo "Can't find kernel image '${kernelImage}'" >&2
719     usage
720     exit 1
721     fi
722     ;;
723    
724 niro 924 -v)
725     verbose=-v
726     ;;
727 niro 532
728 niro 924 *)
729     if [[ -z ${mode} ]]
730     then
731     mode=$1
732     elif [[ -z ${version} ]]
733     then
734     version=$1
735     else
736     usage
737     fi
738     ;;
739     esac
740 niro 532
741 niro 924 shift
742 niro 532 done
743    
744     # make sure the mode is valid
745 niro 924 if [[ ${mode} != --install ]] && [[ ${mode} != --remove ]] && [[ ${mode} != --update ]]
746     then
747     usage
748 niro 532 fi
749    
750 niro 924 if [[ -z ${version} ]]
751     then
752     usage
753 niro 532 fi
754    
755 niro 924 if [ "${mode}" != "--install" -a "${makedefault}" ]
756     then
757     usage
758 niro 532 fi
759    
760 niro 924 kernelmajor=$(echo ${kernel} | cut -d . -f 1,2)
761 niro 532
762 niro 1305 # kernel image for 2.4 is kernel
763 niro 924 if [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
764     then
765     if [[ ${kernelmajor} = 2.4 ]]
766     then
767     kernelName=kernel
768     fi
769 niro 532 fi
770    
771 niro 2241 [[ ${kernelImage} ]] || kernelImage="${bootPrefix}/${kernelName}-${version}"
772    
773 niro 532 # set the initrd file based on arch; ia64 is the only currently known oddball
774 niro 924 if [[ -z ${initrdfile} ]]
775     then
776     INITRD_NAME_PREFIX="initrd"
777 niro 1334 if [[ -n ${dracut} ]]
778     then
779     INITRD_NAME_PREFIX="initramfs"
780     fi
781 niro 923
782 niro 924 if [[ $(uname -m) = ia64 ]]
783     then
784     initrdfile="/boot/efi/EFI/redhat/${INITRD_NAME_PREFIX}-${version}.img"
785     else
786     initrdfile="/boot/${INITRD_NAME_PREFIX}-${version}.img"
787     fi
788 niro 532 fi
789 niro 924 [[ -n ${verbose} ]] && echo "initrdfile is ${initrdfile}"
790 niro 532
791 niro 1334 # add dracut i18n, keyboard and plymouth kernel args if requested
792     if [[ -n ${dracut} ]] || [[ -n ${adddracutargs} ]]
793     then
794 niro 2059 if [ -r /etc/vconsole.conf ]
795     then
796     . /etc/vconsole.conf
797 niro 1334
798 niro 2059 for i in SYSFONT SYSFONTACM UNIMAP KEYTABLE
799     do
800     val=$(eval echo \$$i)
801     [[ -n ${val} ]] && kernargs="${kernargs} ${i}=${val}"
802     done
803     else
804     if [ -r /etc/conf.d/consolefont ]
805     then
806     . /etc/conf.d/consolefont
807    
808     if [[ -n ${CONSOLEFONT} ]]
809     then
810     kernargs="${kernargs} SYSFONT=${CONSOLEFONT}"
811     fi
812     fi
813    
814     if [ -r /etc/conf.d/keymap ]
815     then
816     . /etc/conf.d/keymap
817    
818     if [[ -n ${KEYMAP} ]]
819     then
820     kernargs="${kernargs} KEYTABLE=${KEYMAP}"
821     fi
822     fi
823 niro 1334 fi
824    
825 niro 2059 if [ -r /etc/locale.conf ]
826 niro 1334 then
827 niro 2059 . /etc/locale.conf
828    
829     if [[ -n ${LANG} ]]
830     then
831     kernargs="${kernargs} LANG=${LANG}"
832     fi
833 niro 1334 fi
834     fi
835    
836 niro 532 # set this as the default if we have the package and it matches
837 niro 924 if [[ ${mode} = --install ]] && [[ ${UPDATEDEFAULT} = yes ]] && [[ -n ${package} ]] &&
838     [[ -n ${DEFAULTKERNEL} ]] && [[ ${package} = ${DEFAULTKERNEL} ]]
839     then
840     makedefault="--make-default"
841     [[ -n ${verbose} ]] && echo "making it the default based on config"
842 niro 532 fi
843    
844 niro 924 if [[ ${moddep} = make ]]
845     then
846     doDepmod
847     elif [[ ${moddep} = remove ]]
848     then
849     doRmmoddep
850 niro 532 fi
851    
852 niro 924 if [[ ${initrd} = make ]]
853     then
854 niro 1756 makeinitrd
855 niro 924 elif [[ ${initrd} = remove ]]
856     then
857     rminitrd
858 niro 532 fi
859    
860 niro 924 if [ ! -x ${grubby} ]
861     then
862     [[ -n ${verbose} ]] && echo "${grubby} does not exist"
863     exit 0
864 niro 532 fi
865    
866 niro 924 [[ -n ${grubConfig} ]] && [ -f ${grubConfig} ] && cfgGrub=1
867 niro 1697 [[ -n ${grub2Config} ]] && [ -f ${grub2Config} ] && cfgGrub2=1
868     [[ -n ${grub2EfiConfig} ]] && [ -f ${grub2EfiConfig} ] && cfgGrub2Efi=1
869 niro 924 [[ -n ${liloConfig} ]] && [ -f ${liloConfig} ] && cfgLilo=1
870 niro 1716 [[ -n ${extlinuxConfig} ]] && [ -f ${extlinuxConfig} ] && cfgExtlinux=1
871 niro 532
872 niro 1752 # if we have a U-Boot directory, but no boot script, check if the directory
873     # is mounted. If not, mount it, and then check if a boot script exists.
874 niro 1691 if [[ -n ${ubootDir} ]]
875     then
876 niro 1752 if [ -f ${ubootScript} ]
877 niro 1691 then
878 niro 1752 cfguBoot=1
879     else
880     mountEntry=$(mount | grep ${ubootDir})
881     if [[ -z ${mountEntry} ]]
882     then
883     mount ${ubootDevice} ${ubootDir}
884     mounted=1
885     fi
886     [ -f ${ubootScript} ] && cfguBoot=1
887 niro 1691 fi
888     fi
889    
890 niro 1937 # if we're using U-Boot, check if the default load address should change
891     if [[ -n ${cfguBoot} ]] && [[ -z ${UBOOT_IMGADDR} ]]
892     then
893     [[ ${version} =~ .([^.]*)$ ]]
894     platform=${BASH_REMATCH[1]}
895     # A few platforms use an alternate kernel load address
896     if [[ ${platform} = omap ]]
897     then
898     ubootAddress=0x80008000
899     elif [[ ${platform} = imx ]]
900     then
901     ubootAddress=0x90008000
902     fi
903     fi
904    
905 niro 532 # if we have a lilo config on an x86 box, see if the default boot loader
906     # is lilo to determine if it should be run
907 niro 924 if [[ -n ${cfgLilo} ]] && [[ -n ${isx86} ]]
908     then
909     runLilo=$(${grubby} --bootloader-probe | grep lilo)
910 niro 532 fi
911    
912 niro 924 if [[ ${mode} = --install ]]
913     then
914     install
915     elif [[ ${mode} = --remove ]]
916     then
917     remove
918     elif [[ ${mode} = --update ]]
919     then
920     update
921 niro 532 fi
922    
923 niro 1752 # if we mounted the U-Boot directory, unmount it.
924     [[ -n ${mounted} ]] && umount ${ubootDir}
925    
926 niro 532 exit 0

Properties

Name Value
svn:executable *